package ch.zhaw.ads;

import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedList;
import java.util.List;

public class RankingListServer implements CommandExecutor {

    public List<Competitor> createList(String rankingText) {
        List<Competitor> competitorList = new LinkedList<>();
        for(String listEntry : rankingText.split("\\n")){
            String[] entry = listEntry.split(";");
            competitorList.add(new Competitor(0, entry[0], entry[1]));
        }
        return competitorList;
    }

    public String createSortedText(List<Competitor> competitorList) {
        // TODO Implement
        competitorList.sort(new Comparator<Competitor>() {
            @Override
            public int compare(Competitor o1, Competitor o2) {
                int c = o1.compareTo(o2);
                return c;
            }
        });
        StringBuilder stringBuilder = new StringBuilder();
        int rank = 1;
        for (Competitor competitor : competitorList) {
            competitor.setRank(rank);
            stringBuilder.append(competitor.toString()).append("\n");
            rank++;
        }
        return stringBuilder.toString();
    }

    public String createNameList(List<Competitor> competitorList) {
        // TODO Implement
        competitorList.sort(new AlphaComparatorCompetitor());
        StringBuilder stringBuilder = new StringBuilder();
        int rank = 0;
        for (Competitor competitor : competitorList) {
            stringBuilder.append(competitor.toString()).append("\n");
        }
        return stringBuilder.toString();
    }

    public String execute(String rankingList) {
        List<Competitor> competitorList = createList(rankingList);
        return "Rangliste\n" + createSortedText(competitorList);
    }
}
